const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const historico_alteracoes_projeto = sequelize.define(
    'historico_alteracoes_projeto',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      data_alteracao: {
        type: DataTypes.DATE,
      },

      tipo_alteracao: {
        type: DataTypes.TEXT,
      },

      descricao_anterior: {
        type: DataTypes.TEXT,
      },

      descricao_nova: {
        type: DataTypes.TEXT,
      },

      motivo_alteracao: {
        type: DataTypes.TEXT,
      },

      responsavel_alteracao: {
        type: DataTypes.TEXT,
      },

      comentarios: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  historico_alteracoes_projeto.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.historico_alteracoes_projeto.belongsTo(db.estrutura_projeto, {
      as: 'estrutura',
      foreignKey: {
        name: 'estruturaId',
      },
      constraints: false,
    });

    db.historico_alteracoes_projeto.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.historico_alteracoes_projeto.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.historico_alteracoes_projeto.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return historico_alteracoes_projeto;
};
